CREATE TABLE USERS
(
  ID_USER     NUMBER,
  USER_NAME   VARCHAR2(100),
  USER_EMAIL  VARCHAR2(50)
);

ALTER TABLE JIGLOG.USERS ADD (CONSTRAINT USERS_PK PRIMARY KEY (ID_USER));

BEGIN
  INSERT INTO USERS (ID_USER, USER_NAME, USER_EMAIL) VALUES (1, 'Ferko Mrkvicka', 'ferko.mrkvicka@server.com');
  INSERT INTO USERS (ID_USER, USER_NAME, USER_EMAIL) VALUES (2, 'Anna Dobra', 'anna.dobra@server.com');
  COMMIT;
END
/


CREATE OR REPLACE 
FUNCTION Send_email(v_Subject_par in varchar2, 
                    v_Msg_par in varchar2, 
                    v_Error in out varchar2,
                    v_Recipient_par in varchar2 := '') RETURN BOOLEAN IS
    v_Mail_From CONSTANT VARCHAR2(50) := 'programator@firma.sk';        
    v_Mail_Host CONSTANT VARCHAR2(20) := '10.150.100.103';
    v_Mail_Port CONSTANT NUMBER := 25;
    crlf CONSTANT VARCHAR2(2) := chr(13) || chr(10);
    v_Mail_Conn UTL_SMTP.CONNECTION;
BEGIN
    v_Error := NULL;
    IF v_Recipient_par IS NULL THEN
        FOR USER_REC IN (SELECT USER_EMAIL FROM USERS)
        LOOP
            BEGIN
                v_Mail_Conn := UTL_SMTP.OPEN_CONNECTION(v_Mail_Host, v_Mail_Port);
            EXCEPTION
                WHEN OTHERS THEN
                    v_Error := 'Function Send_email:' || SQLERRM;
                    RETURN FALSE;
            END;                    
            UTL_SMTP.HELO(v_Mail_Conn, v_Mail_Host);
            UTL_SMTP.MAIL(v_Mail_Conn, v_Mail_From);
            UTL_SMTP.RCPT(v_Mail_Conn, USER_REC.USER_EMAIL);
            UTL_SMTP.DATA(v_Mail_Conn,
                          'Date: '   || to_char(sysdate, 'Dy, DD Mon YYYY hh24:mi:ss') || crlf ||
                          'From: '   || v_Mail_From || crlf ||
                          'Subject: '|| v_Subject_par || crlf ||
                          'To: '     || USER_REC.USER_EMAIL || crlf || crlf ||
                          v_Msg_par 
                        );
            UTL_SMTP.QUIT(v_mail_conn);          
        END LOOP;
    ELSE
        BEGIN        
            v_Mail_Conn := UTL_SMTP.OPEN_CONNECTION(v_Mail_Host, v_Mail_Port);
        EXCEPTION
            WHEN OTHERS THEN
                v_Error := 'Function Send_email: ' || SQLERRM;
                RETURN FALSE;
        END;                
        UTL_SMTP.HELO(v_Mail_Conn, v_Mail_Host);
        UTL_SMTP.MAIL(v_Mail_Conn, v_Mail_From);
        UTL_SMTP.RCPT(v_Mail_Conn, v_Recipient_par);
        UTL_SMTP.DATA(v_Mail_Conn, 'Date: '   || to_char(sysdate, 'Dy, DD Mon YYYY hh24:mi:ss') || crlf ||
                                   'From: '   || v_Mail_From || crlf ||
                                   'Subject: '|| v_Subject_par || crlf ||
                                   'To: '     || v_Recipient_par || crlf || crlf ||
                                   v_Msg_par --|| crlf || crlf || ' from ' || v_Mail_Host
                     );
        UTL_SMTP.QUIT(v_mail_conn);        
    END IF;    
        
    RETURN TRUE;
EXCEPTION
    WHEN UTL_SMTP.INVALID_OPERATION THEN
        v_Error := 'Invalid Operation in Mail attempt using UTL_SMTP. (Function: Send_email)';
        RETURN FALSE;
    WHEN UTL_SMTP.TRANSIENT_ERROR THEN
        UTL_SMTP.QUIT(v_mail_conn);
        v_Error := 'Temporary e-mail issue - try again. (Function: Send_email)'; 
        RETURN FALSE;
    WHEN UTL_SMTP.PERMANENT_ERROR THEN
        UTL_SMTP.QUIT(v_mail_conn);
        v_Error := 'Permanent error has encountered. (Function: Send_email)';
        RETURN FALSE;
    WHEN OTHERS THEN
        v_Error := 'Function Send_email:' || SQLERRM;
        RETURN FALSE;   
END
/

SET SERVEROUTPUT ON
DECLARE
  v_Error VARCHAR2(1000);
  v_Result BOOLEAN;
BEGIN
//    v_Result := Send_email('Pozdrav z www.projectik.eu','Pozdravujeme Vas!',v_Error); 	
    v_Result := Send_email('Pozdrav z www.projectik.eu','Pozdravujeme Vas!',v_Error,'ferko.mrkvicka@server.com'); 
    IF v_Result THEN
        DBMS_OUTPUT.PUT_LINE('Mail bol uspesne odoslany.');
    ELSE
        DBMS_OUTPUT.PUT_LINE('Mail sa nepodarilo odoslat: '||v_Error);
    END IF;
END
/